rem From %1, the text output from "-verbose" triangulate,
rem makes %2_l.png, %2_t.png and %2_c.png
rem showing lines, triangles and convex hull.

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave


set INLIS=%1

set OUTBASE=%2
if "%OUTBASE%"=="" set OUTBASE=data

set OUTLINES=%OUTBASE%_l.png
set OUTTRI=%OUTBASE%_t.png
set OUTCONV=%OUTBASE%_c.png

rem type %INLIS%

for /F "tokens=2,3 usebackq delims=:, " %%A in (`cGrep /p0 /i%INLIS% /sMaxCoord:*`) do (
  set /A WW=%%A+1
  set /A HH=%%B+1
)

set /A PNTSIZE=%WW%/60
if %PNTSIZE% LSS 20 set PNTSIZE=20
set /A H_MARG=%PNTSIZE%*3/2
set /A V_MARG=%PNTSIZE%*3/4

set /A Wm=%WW%-%H_MARG%
set /A Hm=%HH%-%V_MARG%

cGrep /i%INLIS% /opoints.txt /s"point:"

(for /F "tokens=2,3 usebackq delims=:, " %%A in (`cGrep /p0 /i%INLIS% /s*point:*`) do @(
  @set /A newY=%%B+50
  @echo circle %%A,%%B,%%A,!newY!
)) >points2.txt

(for /F "tokens=2-4 usebackq delims=:,# " %%A in (`cGrep /p0 /i%INLIS% /s*point:*`) do @(
  @set /A x=%%A
  @set /A y=%%B
  @if !x! GTR %Wm% set /A x=!x!-%H_MARG%
  @if !y! LSS %V_MARG% set /A y=%V_MARG%
  @echo text !x!,!y! "%%C"
)) >pointsNum.txt

(for /F "tokens=2-6 usebackq delims=:,# " %%A in (`cGrep /p0 /i%INLIS% /s*edge:*`) do @(
  @set /A x=^(%%A+%%C^)/2
  @set /A y=^(%%B+%%D^)/2
  @if !x! GTR %Wm% set /A x=!x!-%H_MARG%
  @if !y! LSS %V_MARG% set /A y=%V_MARG%
  @echo text !x!,!y! "%%E"
)) >edgeNum.txt

(for /F "tokens=2-7 usebackq delims=:,# " %%A in (`cGrep /p0 /i%INLIS% /s*triangle:*`) do @(
  @echo polygon %%A,%%B %%C,%%D %%E,%%F
)) >tri.txt

set count=0
(for /F "tokens=2-7 usebackq delims=:,# " %%A in (`cGrep /p0 /i%INLIS% /s*triangle:*`) do @(
  @set /A x=^(%%A+%%C+%%E^)/3
  @set /A y=^(%%B+%%D+%%F^)/3
  @if !x! GTR %Wm% set /A x=!x!-%H_MARG%
  @if !y! LSS %V_MARG% set /A y=%V_MARG%
  @echo text !x!,!y! "!count!"
  @set /A count+=1
)) >triNum.txt

chStrs  /p0 /ipoints.txt /f"  point: "     /t"\0"
chStrs  /p0 /ipoints.txt /f" "     /t","
cPrefix /p0 /ipoints.txt /l"translate " /r" circle 0,0 0,20"

rem type points.txt

rem type points2.txt

cGrep  /p0 /i%INLIS% /olines.txt /s"edge:"
chStrs /p0 /ilines.txt /f"edge:"     /t"line"

%IM%convert ^
  -size %WW%x%HH% xc:None ^
  -stroke #000 -fill None ^
  -draw "@lines.txt" ^
  -pointsize %PNTSIZE% -fill #a00 -stroke None ^
  -undercolor rgba(100%%,100%%,100%%,0.5) ^
  -draw "@pointsNum.txt" ^
  -fill #00f ^
  -draw "@edgeNum.txt" ^
  -fill #080 ^
  -draw "@triNum.txt" ^
  %OUTLINES%

%IM%convert ^
  -size %WW%x%HH% xc: ^
  -fill rgba(75%%,75%%,100%%,0.5) ^
  -draw "@tri.txt" ^
  -stroke #000 -fill None ^
  -draw "@lines.txt" ^
  -pointsize %PNTSIZE% -stroke None ^
  -fill #080 ^
  -draw "@triNum.txt" ^
  %OUTTRI%

%IM%convert ^
  -size %WW%x%HH% xc:#000 ^
  -fill #fff ^
  -draw "@tri.txt" ^
  %OUTCONV%

call echoRestore

@endlocal
