rem Richardson-Lucy deconvolution.
rem %1 is image.
rem %2 is kernel (PSF).
rem %3 is number of iterations (default 10).
rem %4 is optional name of output file.
@rem
@rem Ref http://en.wikipedia.org/wiki/Richardson%E2%80%93Lucy_deconvolution
@rem
@rem We need option to NOT convert to linear.

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

rem @call echoOffSave

call %PICTBAT%setInOut %1 drl

set NITER=%3
if "%NITER%"=="." set NITER=
if "%NITER%"=="" set NITER=10

if not "%4"=="" set OUTFILE=%4

set TMPDIR=%CYGTEMP%/
set TMPEXT=.miff

set PSF=%2
set PSFHAT=%TMPDIR%drl_psfhat%TMPEXT%
set EST=%TMPDIR%drl_est%TMPEXT%
set TMPIN=%TMPDIR%drl_in%TMPEXT%

%IMDEV%convert ^
  %PSF% ^
  -flip -flop ^
  %PSFHAT%

%IMDEV%convert ^
  %INFILE% ^
  -colorspace RGB ^
  +depth ^
  -write %TMPIN% ^
  %EST%

rem  -fill gray50 -colorize 100


rem for /F "usebackq" %%L in (`%IMDEV%convert ^
rem   %PSF% -process img2knl NULL:`) do set PSF_KNL=%%L

rem for /F "usebackq" %%L in (`%IMDEV%convert ^
rem   %PSFHAT% -process img2knl NULL:`) do set PSFHAT_KNL=%%L

%IMDEV%convert ^
  %PSF% -process img2knl NULL: >psf_knl.txt

%IMDEV%convert ^
  %PSFHAT% -process img2knl NULL: >psfhat_knl.txt

for /L %%i in (1,1,%NITER%) do %IMDEV%convert ^
  %EST% ^
  ( +clone ^
    ( +clone ^
      -define convolve:scale="^!" ^
      -morphology convolve @psf_knl.txt ^
      %TMPIN% ^
      -compose DivideDst -composite ^
      -morphology convolve @psfhat_knl.txt ^
    ) ^
    -compose Multiply -composite ^
  ) ^
  ( -clone 0-1 ^
    -metric RMSE ^
    -format "%%[distortion]\n" -compare -write info: ^
    -delete 0-1 ^
  ) ^
  -delete 0 ^
  +depth ^
  %EST%

%IMDEV%convert ^
  %EST% ^
  -set colorspace RGB ^
  -colorspace sRGB ^
  +depth ^
  %OUTFILE%
