rem @echo off

rem See \prose\pictures\hex.bat

setlocal

set SRC=%1

set nRows=%3
if "%nRows%"=="" set nRows=2

set STYLE=%4
if "%STYLE%"=="" set STYLE=RESIZE

FOR /F %%i IN ('%IM%identify -format "%%[fx:int(2*%Height%/sqrt(3)+0.5)]" xc:') DO set TriSide=%%i

set /A SemiTriSide=%TriSide%/2
set /A semiWi=%Width%/2
set /A wim1=%Width%-1
set /A htm1=%Height%-1
set /A TriLeft=(%Width%-%TriSide%)/2
set /A TriRight=(%Width%+%TriSide%)/2
set /A CanvasWi=%TriSide%*3
set /A CanvasSemiWi=%TriSide%*3/2
set /A Canv23=%TriSide%*2
set /A Canv13=%TriSide%

"%IMFX%convert" ^
  -size %Width%x%Height% xc:White ^
  -set colorspace RGB ^
  -fill #000 ^
  -draw "polygon 0,0 %semiWi%,0 %TriLeft%,%htm1% 0,%htm1%" ^
  -colorspace sRGB ^
  -write %FXTEMP%hexBlankL.png ^
  -flop ^
  %FXTEMP%hexBlankR.png

"%IMFX%convert" ^
  -size %CanvasWi%x%Height% xc:Green ^
  -gravity North ^
  %SRC% ^
  -compose Over -composite ^
  -write %FXTEMP%hexOnCanv.png ^
  %FXTEMP%hexBlankR.png ^
  -compose CopyOpacity -composite ^
  ( +clone -flip -write %FXTEMP%hexL3.png +delete ) ^
  -virtual-pixel None ^
  -distort SRT "%CanvasSemiWi%,0 -1,1 -60 %CanvasSemiWi%,0" ^
  %FXTEMP%hexR.png

"%IMFX%convert" ^
  %FXTEMP%hexOnCanv.png ^
  %FXTEMP%hexBlankL.png ^
  -gravity North ^
  -compose CopyOpacity -composite ^
  ( +clone -flip -write %FXTEMP%hexR3.png +delete ) ^
  -virtual-pixel None ^
  -distort SRT "%CanvasSemiWi%,0 -1,1 60 %CanvasSemiWi%,0" ^
  %FXTEMP%hexL.png

"%IMFX%convert" ^
  %FXTEMP%hexOnCanv.png ^
  -virtual-pixel None ^
  ( +clone ^
    -distort SRT "%Canv23%,%htm1% 1,1 120 %Canv23%,%htm1%" ^
    -write %FXTEMP%hexR2.png +delete ) ^
  -distort SRT "%Canv13%,%htm1% 1,1 -120 %Canv13%,%htm1%" ^
  %FXTEMP%hexL2.png

"%IMFX%convert" ^
  %FXTEMP%hexOnCanv.png ^
  -gravity North ^
  %FXTEMP%hexR.png ^
  -composite ^
  %FXTEMP%hexR2.png ^
  -composite ^
  %FXTEMP%hexL.png ^
  -composite ^
  %FXTEMP%hexL2.png ^
  -composite ^
  ( %FXTEMP%hexL3.png -geometry -%CanvasSemiWi%+0 ) ^
  -composite ^
  ( %FXTEMP%hexR3.png -geometry +%CanvasSemiWi%+0 ) ^
  -composite ^
  %FXTEMP%hexX.png

rem  -crop %Width%x%Height%+0+0 ^
rem  hexXc.png

rem If nRows==1, we've got it.
if %nRows%==1 goto skipMult

set sThird=
if %nRows%==3 set sThird=+clone -swap 0,1

rem "%IMFX%convert" ^
rem   hexX.png ^
rem   ( +clone -flip ) ^
rem   -append ^
rem   hexX2.png

"%IMFX%convert" ^
  %FXTEMP%hexX.png ^
  ( +clone -flip ) ^
  %sThird% ^
  -append ^
  %FXTEMP%hexX.png

:skipMult
rem hexX.png is %CanvasWi% wide, %Height% * nRows high.

set sResize=
set sCrop=
set sPad=

rem Where are these supposed to come from?
set nWi=0
set nHt=0

echo STYLE = %STYLE%
echo nWi=%nWi% nHt=%nHt%

if /I %STYLE% EQU CROP (
  echo Crop
  rem set sCrop=-gravity Center -crop %Width%x%Height%+0+0 +repage
  set /A cropWi=%Width%
  set /A cropHt=%Height%
) else if /I %STYLE% EQU RESIZE (
  echo Resize
  set sResize=-resize "%Width%x%Height%^^^! "
  set /A cropWi=0
) else if /I %STYLE% EQU CROPRESIZE (
  echo CropResize
rem FIXME
  if %nWi% EQU %nHt% (
    echo No crop
    set /A cropWi=0
  ) else if %nWi% GTR %nHt% (
    set /A cropWi=%Width%*%nHt%
    set /A cropHt=%Height%*%nHt%
  ) else (
    set /A cropWi=%Width%*%nWi%
    set /A cropHt=%Height%*%nWi%
  )
  set sResize=-resize "%Width%x%Height%^^^! "
) else if /I %STYLE% EQU RESIZEPAD (
  echo ResizePad
  set sResize=-resize "%Width%x%Height%"
  set sPad=-size %Width%x%Height% xc:%fxBackground% +swap -gravity Center -compose Over -composite
  set /A cropWi=0
) else (
  echo fxTri: Bad style [%STYLE%]
  exit /B 1
)

if not %cropWi%==0 set sCrop=-gravity Center -crop %cropWi%x%cropHt%+0+0 +repage

"%IMFX%convert" ^
  %FXTEMP%hexX.png ^
  %sCrop% ^
  %sResize% ^
  %sPad% ^
  %WrFileOptions% ^
  %2

"%IMFX%identify" %2

@echo on
