rem From image %1 with height=1,
rem makes a graph with same width but max height=256.
@rem
@rem Optional:
@rem   %2 is background colour (default Khaki).
@rem   %3 is grid (default 0 = no grid).
@rem   %4 is output filename.

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 g1d


set BACKCOL=%2
if "%BACKCOL%"=="." set BACKCOL=
if "%BACKCOL%"=="" set BACKCOL=Khaki

set GRID_SPEC=%3
if "%GRID_SPEC%"=="." set GRID_SPEC=
if "%GRID_SPEC%"=="" set GRID_SPEC=0

if not "%4"=="" set OUTFILE=%4

set TXTFILE=%TEMP%\sp.txt

for /F "usebackq" %%L ^
in (`%IM%identify -format "WW=%%w\nHH=%%h" %INFILE%`) ^
do set %%L

set S_RESIZE=
if %WW% GTR 1000 (
  set S_RESIZE=-resize 1000x%HH%
  set WW=1000
)

set newH=256

if %WW% LSS 256 (
  set newH=%WW%
)

set S_GRID=
if not %GRID_SPEC%==0 (
  call %PICTBAT%grid %WW% %newH% 4 3 1
  set S_GRID=grid.png -compose Exclusion -composite
)



echo WW=%WW% newH=%newH%

set /A newH4=4*%newH%

%IM%convert ^
  %INFILE% ^
  -scale "%WW%x1^!" ^
  -scale "%WW%x%newH%^!" ^
  ( -clone 0 ^
    -fill %BACKCOL% -colorize 100 ^
  ) ^
  ( -clone 0 -scale "%WW%x%newH4%^!" ^
    -size %WW%x%newH4% gradient: ^
    -compose MinusDst -composite ^
    -threshold 0 ^
    -resize "%WW%x%newH%^!" ^
  ) ^
  -compose Over -composite ^
  %S_GRID% ^
  -bordercolor Black -border 1x1 ^
  %OUTFILE%


call echoRestore
