rem From image %1 with height=1,
rem makes a colour line graph with same width but max height=256.
@rem
@rem Optional:
@rem   %2 is background colour, can be "none" (default Black).
@rem   %3 is grid (default 0 = no grid).
@rem   %4 is whether to show clut below graph (default 1 = do show).

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal disabledelayedexpansion
@rem Otherwise ! in LINE_IMG causes IM to misread.

@call echoOffSave

call %PICTBAT%setInOut %1 glc

set BACKCOL=%2
if "%BACKCOL%"=="." set BACKCOL=
if "%BACKCOL%"=="" set BACKCOL=#000

set GRID_SPEC=%3
if "%GRID_SPEC%"=="." set GRID_SPEC=
if "%GRID_SPEC%"=="" set GRID_SPEC=0

set SHOW_CLUT=%4
if "%SHOW_CLUT%"=="." set SHOW_CLUT=
if "%SHOW_CLUT%"=="" set SHOW_CLUT=1

if not "%5"=="" set OUTFILE=%5


FOR /F "usebackq" %%L IN (`%IM%identify ^
  -format "WW=%%w\nHH=%%h" ^
  %INFILE%`) DO set %%L

set S_RESIZE=
if %WW% GTR 1000 (
  set S_RESIZE=-resize 1000x%HH%
  set WW=1000
)

set newH=256

if %WW% LSS 256 (
  set newH=%WW%
)

if %GRID_SPEC%==0 (
  set S_GRID=
) else (
  call %PICTBAT%grid %WW% %newH% 20 4 . gray50
  set S_GRID=grid.png -compose Exclusion -composite
)

set /A newH4=4*%newH%

if /I %BACKCOL%==none (
  set sBACK=
) else (
  set sBACK=-background %BACKCOL% -compose Over -flatten
)

set sBORD=-bordercolor Black -border 1x1
set sBORD=

set LINE_IMG=-separate +channel -scale "%WW%x%newH4%^!" ^
    -size %WW%x%newH4% gradient: ^
    -compose MinusDst -composite ^
    -fill #fff +opaque #000 ^
    -resize "%WW%x%newH%^!" ^
    -morphology edgeout diamond:1

set /A SHOW_CLUT_HT=%WW%/10
if %SHOW_CLUT_HT% LSS 25 set SHOW_CLUT_HT=25

if %SHOW_CLUT%==0 (
  set sCLUT=
) else (
  set sCLUT= ^( %INFILE% -scale "%WW%x%SHOW_CLUT_HT%^!" ^) -append
)

rem %IMDEV%convert %INFILE% -depth 16 %TEMP%\glc.png
rem set INFILE=%TEMP%\glc.png

%IM%convert ^
  "%INFILE%" ^
  -scale "%WW%x1^!" ^
  -scale "%WW%x%newH%^!" ^
  ( -clone 0 ^
    ( -clone 0 ^
      -fill #f00 -colorize 100 ^
    ) ^
    ( -clone 0 -channel R %LINE_IMG% ) ^
    -delete 0 ^
    -alpha off ^
    -compose CopyOpacity -composite ^
  ) ^
  ( -clone 0 ^
    ( -clone 0 ^
      -fill #0f0 -colorize 100 ^
    ) ^
    ( -clone 0 -channel G %LINE_IMG% ) ^
    -delete 0 ^
    -alpha off ^
    -compose CopyOpacity -composite ^
  ) ^
  ( -clone 0 ^
    ( -clone 0 ^
      -fill #44f -colorize 100 ^
    ) ^
    ( -clone 0 -channel B %LINE_IMG% ) ^
    -delete 0 ^
    -alpha off ^
    -compose CopyOpacity -composite ^
  ) ^
  -delete 0 ^
  ( -clone 0-1 -compose Lighten -composite ) -delete 0-1 ^
  -compose Lighten -composite ^
  %sBACK% ^
  %S_GRID% ^
  %sBORD% ^
  %sCLUT% ^
  %OUTFILE%

if ERRORLEVEL 1 (
  echo Problem in %0
  exit /B 1
)

call echoRestore
