rem Given %1 is a 2-D absolute displacement map,
rem where each row displaces horizontally and either increases or decreases but not both,
rem makes the inverse by inverting each line separately.
rem %2 is channel. Default RGB.
rem %3 is 0=all rows increase or 1=all rows decrease. Default 0.

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 iad

set sCHANNEL=%2
if "%sCHANNEL%"=="" set sCHANNEL=RGB

set NEG=%3
if "%NEG%"=="" set NEG=0


rem @-files can't have drive, so can't be %TEMP%
set FSCRIPT=%~n1_iad.scr
set FGRAD=%TEMP%\%~n1_iad.miff

del /q %FSCRIPT%

FOR /F "usebackq" %%L ^
IN (`%IM%identify -format "WW=%%w\nHH=%%h\nWm1=%%[fx:w-1]\nHm1=%%[fx:h-1]" %INFILE%`) ^
DO set %%L


set sNEG=
if %NEG%==1 set sNEG=-negate

echo %INFILE% >%FSCRIPT%
echo -size %WW%x%WW% gradient: >>%FSCRIPT%
for /L %%Y in (0,1,%Hm1%) do (
  echo ^( -clone 0 -crop %WW%x1+0+%%Y +repage -scale "%WW%x%WW%^!" -clone 1 -compose MinusDst -composite -channel %sCHANNEL% -threshold 0 %sNEG% +channel -scale "1x%WW%^!" -rotate 90 ^)>>%FSCRIPT%
)

"%IM%convert" ^
  @%FSCRIPT% ^
  -delete 0-1 ^
  -append ^
  %OUTFILE%

if ERRORLEVEL 1 (
  echo @0: failed for @*
  exit /B 1
)

%IM%identify %OUTFILE%

call echoRestore
