rem For image %1, find the angle a, -90 <= a <= +90, that minimises the trimmed width.
rem %2 is 0 (default, minimise width) or 1 (minimise height)
rem Assumes pixel at (0,0) is background colour.

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

set INFILE=%1
set TEMPFILE=%TEMP%\%~n1_rmw.miff

if "%2"=="1" (
  set TOKENS=tokens=2
) else (
  set TOKENS=
)


%IM%convert %INFILE% -background White -layers flatten -resize 500x500 %TEMPFILE%

rem  

for /F "usebackq" %%C ^
in (`%IM%convert %TEMPFILE% -format "%%[pixel:p{0,0}]" info:`) ^
do set ONE_PIXEL=%%C

%IM%convert %TEMPFILE% -bordercolor %ONE_PIXEL% -border 1 %TEMPFILE%

set ANG0=-90
set ANG3=90

for /F "usebackq" %%L ^
in (`%IM%convert ^
  %TEMPFILE% ^
  -background "%ONE_PIXEL%" ^
  -format "Tn=%%@\n" -write info: ^
  ^( +clone -rotate -30 -format "Tx=%%@\n" -write info: +delete ^) ^
  ^( +clone -rotate %ANG0% -format "T0=%%@\n" -write info: +delete ^) ^
  ^( +clone -rotate %ANG3% -format "T3=%%@\n" -write info: +delete ^) ^
  NULL:`) ^
do set %%L

for /F "%TOKENS% delims=x+" %%L in ("%T0%") do set W0=%%L
for /F "%TOKENS% delims=x+" %%L in ("%T3%") do set W3=%%L

set FINISHED=0

:loop

for /F "usebackq" %%L ^
in (`%IM%identify -format "ANG1=%%[fx:%ANG0%+(%ANG3%-(%ANG0%))/3]\nANG2=%%[fx:%ANG0%+2*(%ANG3%-(%ANG0%))/3]" xc:`) ^
do set %%L

for /F "usebackq" %%L ^
in (`%IM%convert ^
  %TEMPFILE% ^
  -background "%ONE_PIXEL%" ^
  ^( +clone -rotate %ANG1% -format "T1=%%@\n" -write info: +delete ^) ^
  ^( +clone -rotate %ANG2% -format "T2=%%@\n" -write info: +delete ^) ^
  NULL:`) ^
do set %%L

for /F "%TOKENS% delims=x+" %%L in ("%T1%") do set W1=%%L
for /F "%TOKENS% delims=x+" %%L in ("%T2%") do set W2=%%L

if %ANG0%==%ANG1% (
  set FINISHED=1
  goto finished
)

if %ANG2%==%ANG3% (
  set FINISHED=1
  goto finished
)

if %W0%==%W1% if %W0%==%W2% if %W0%==%W3% (
  set FINISHED=1
  goto finished
)

set FINISHED=1

if %W1% LEQ %W0% if %W1% LEQ %W2% if %W1% LEQ %W3% (
  set ANG3=%ANG2%
  set W3=%W2%
  set FINISHED=0
)

if %FINISHED%==1 if %W2% LEQ %W0% if %W2% LEQ %W1% if %W2% LEQ %W3% (
  set ANG0=%ANG1%
  set W0=%W1%
  set FINISHED=0
)

if %FINISHED%==1 if %W3% LEQ %W0% if %W3% LEQ %W1% if %W3% LEQ %W2% (
  set ANG0=%ANG2%
  set W0=%W2%
  set FINISHED=0
)

echo Ang:   %ANG0% %ANG1% %ANG2% %ANG3%
echo Width: %W0% %W1% %W2% %W3%

if %FINISHED%==0 goto loop

:finished


call echoRestore

endlocal & set rmwANG=%ANG1%
